<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\CSModel;
use App\Helpers\Part\CSHelper;
use App\Forms\Part\CSForm;
use App\Entities\Part\CSEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\CommonEntity;
use App\DTOs\Part\CSDTO;

class CSService extends PartType2Service
{
    private $_form = null;
    private $_helper = null;
    public function __construct(CSModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('CS');
    }
    protected function getDTOClass(): string
    {
        return CSDTO::class;
    }
    public function createDTO(array $formDatas): CSDTO
    {
        return new CSDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return CSEntity::class;
    }
    public function getFormService(): CSForm
    {
        if ($this->_form === null) {
            $this->_form = new CSForm();
            $this->_form->setAttributes([
                'pk_field'         => $this->model->getPKField(),
                'title_field'      => $this->model->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): CSHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new CSHelper();
            $this->_helper->setAttributes([
                'pk_field'         => $this->model->getPKField(),
                'title_field'      => $this->model->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    public function action_init_process(string $action, array $formDatas = []): void
    {
        $fields = [
            "type",
            "ip",
            "accountid",
            "domain",
            "price",
        ];
        $filters = [
            "clientinfo_uid",
            'serverinfo_uid',
            'type',
            'status'
        ];
        $indexFilter     = $filters;
        $batchjobFilters = ['status'];
        switch ($action) {
            case 'create':
            case 'create_form':
            case 'modify':
            case 'modify_form':
                $fields = [...$fields, 'status'];
                break;
            case 'view':
                $fields = [
                    ...$fields,
                    "clientinfo_uid",
                    'serverinfo_uid',
                    'type',
                    'ip',
                    'accountid',
                    'domain',
                    'price',
                    'status',
                    'created_at'
                ];
                break;
            case 'index':
            case 'download':
                $fields = [
                    ...$fields,
                    "clientinfo_uid",
                    'serverinfo_uid',
                    'type',
                    'ip',
                    'accountid',
                    'domain',
                    'price',
                    'status',
                    'created_at'
                ];
                break;
        }
        $this->getFormService()->setFormFields($fields);
        $this->getFormService()->setFormRules($action, $fields);
        $this->getFormService()->setFormFilters($filters);
        $this->getFormService()->setFormOptions($action, $filters, $formDatas);
        $this->getFormService()->setIndexFilters($indexFilter);
        $this->getFormService()->setBatchjobFilters($batchjobFilters);
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): CSEntity
    {
        return $entity;
    }
    protected function create_process(array $formDatas): CSEntity
    {
        return parent::create_process($formDatas);
    }
    protected function modify_process($entity, array $formDatas): CSEntity
    {
        return parent::modify_process($entity, $formDatas);
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리(INET_ATON() 함수를 사용)
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy("INET_ATON(ip) ASC");
        parent::setOrderBy($field, $value);
    }

    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): CSEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUID());
        if (!$entity instanceof CSEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUID()}에 해당하는 CS정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function attachToServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): CSEntity
    {
        /** @var CSEntity $entity IDE에 entity type알려주기*/
        $entity = parent::attachToServerPart($serverPartEntity, $formDatas);
        return $entity;
    }
    public function detachFromServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): CSEntity
    {
        /** @var CSEntity $entity IDE에 entity type알려주기*/
        $entity = parent::detachFromServerPart($serverPartEntity, $formDatas);
        return $entity;
    }
}
